// Code generated by go-swagger; DO NOT EDIT.

// Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License"). You may
// not use this file except in compliance with the License. A copy of the
// License is located at
//
// 	http://aws.amazon.com/apache2.0/
//
// or in the "license" file accompanying this file. This file is distributed
// on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
// express or implied. See the License for the specific language governing
// permissions and limitations under the License.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// BalloonStatsUpdate Update the statistics polling interval, with the first statistics update scheduled immediately. Statistics cannot be turned on/off after boot.
// swagger:model BalloonStatsUpdate
type BalloonStatsUpdate struct {

	// Interval in seconds between refreshing statistics.
	// Required: true
	StatsPollingIntervals *int64 `json:"stats_polling_interval_s"`
}

// Validate validates this balloon stats update
func (m *BalloonStatsUpdate) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateStatsPollingIntervals(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *BalloonStatsUpdate) validateStatsPollingIntervals(formats strfmt.Registry) error {

	if err := validate.Required("stats_polling_interval_s", "body", m.StatsPollingIntervals); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *BalloonStatsUpdate) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *BalloonStatsUpdate) UnmarshalBinary(b []byte) error {
	var res BalloonStatsUpdate
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
